/*
 * Copyright (C) 2001-2006 Jacek Sieka, arnetheduck on gmail point com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#if !defined(NOTEPAD3_FRAME_H)
#define NOTEPAD3_FRAME_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "FlatTabCtrl.h"
#include "WinUtil.h"

#define NOTEPAD3_MESSAGE_MAP 13

class Notepad3Frame : public MDITabChildWindowImpl<Notepad3Frame, RGB(0, 0, 0), IDR_NOTEPAD>, public StaticFrame<Notepad3Frame, ResourceManager::NOTEPAD3, IDC_NOTEPAD3>, 
	private SettingsManagerListener
{
public:
	DECLARE_FRAME_WND_CLASS_EX(_T("Notepad3Frame"), IDR_NOTEPAD, 0, COLOR_3DFACE);

	Notepad3Frame() : dirty(false), closed(false), 
		ctrlClientContainer(_T("edit"), this, NOTEPAD3_MESSAGE_MAP) {
		SettingsManager::getInstance()->addListener(this);
	}
	~Notepad3Frame() { }
	
	typedef MDITabChildWindowImpl<Notepad3Frame, RGB(0, 0, 0), IDR_NOTEPAD> baseClass;
	BEGIN_MSG_MAP(Notepad3Frame)
		MESSAGE_HANDLER(WM_SETFOCUS, OnFocus)
		MESSAGE_HANDLER(WM_CREATE, OnCreate)
		MESSAGE_HANDLER(WM_CLOSE, onClose)
		MESSAGE_HANDLER(WM_CTLCOLOREDIT, onCtlColor)
		MESSAGE_HANDLER(WM_CTLCOLORSTATIC, onCtlColor)
		CHAIN_MSG_MAP(baseClass)
	ALT_MSG_MAP(NOTEPAD3_MESSAGE_MAP)
		MESSAGE_HANDLER(WM_LBUTTONDBLCLK, onLButton)
	END_MSG_MAP()

	LRESULT OnCreate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled);
	LRESULT onClose(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled);
	LRESULT onLButton(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled);
	void UpdateLayout(BOOL bResizeBars = TRUE);
	
	LRESULT onCtlColor(UINT /*uMsg*/, WPARAM wParam, LPARAM lParam, BOOL& bHandled) {
		HWND hWnd = (HWND)lParam;
		HDC hDC = (HDC)wParam;
		if(hWnd == ctrlPad.m_hWnd) {
			::SetBkColor(hDC, WinUtil::bgColor);
			::SetTextColor(hDC, WinUtil::textColor);
			return (LRESULT)WinUtil::bgBrush;
		}
		bHandled = FALSE;
		return FALSE;
	}
	
	
	LRESULT OnFocus(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/) {
		ctrlPad.SetFocus();
		return 0;
	}
	
private:
	
	bool dirty;
	bool closed;
	CEdit ctrlPad;
	CContainedWindow ctrlClientContainer;

	void on(SettingsManagerListener::Save, SimpleXML& /*xml*/) throw();
};

#endif // !defined(NOTEPAD3_FRAME_H)

/**
 * @file
 * $Id: Notepad3Frame.h 308 2007-12-27 17:27:20 Lord.Sabbath $
 */
